const express = require('express');

const xml = require('js2xmlparser');

const regionApp = express();

const libs = `${process.cwd()}/libs`;

const log = require(`${libs}/log`)(module);

const conn = require(`${libs}/db/monet`);

function response(req, res) {
    if (req.query.format === 'csv') {
        res.csv(req.result.data);
    } else if (req.query.format === 'xml') {
        res.send(xml('result', JSON.stringify({ state: req.result.data })));
    } else {
        res.json({ result: req.result.data });
    }
}

regionApp.get('/', (req, res) => {
    const regionSql = 'SELECT * FROM regioes';
    conn.query(regionSql, true).then(
        (dbResult) => {
            log.debug(dbResult);
            req.result = dbResult;
            response(req, res);
        },
        (dbError) => {
            log.error(`SQL query execution error: ${dbError.message}`);
            // FIXME: change response to HTTP 501 status
            res.json({ error: 'An internal error has occurred' }).end();
        }
    );
});

regionApp.get('/:id', (req, res) => {
    const regionSql = 'SELECT * FROM regioes WHERE pk_regiao_id = ?';
    const regionId = parseInt(req.params.id, 10);
    conn.prepare(regionSql, true).then((dbQuery) => {
        dbQuery.exec([regionId]).then(
            (dbResult) => {
                log.debug(dbResult);
                req.result = dbResult;
                response(req, res);
            },
            (dbError) => {
                log.error(`SQL query execution error: ${dbError.message}`);
                // FIXME: change response to HTTP 501 status
                res.json({ error: 'An internal error has occurred' }).end();
            }
        );
    });
});

module.exports = regionApp;
